/*************************************************************************
    formattrack.c -- last change: 11-11-1996

    Multitrack is a program to play, record and manipulate tracks. The
    tracks are stored on disk.

    Copyright (C) 1996  Boris Nagels

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    Sent your comments and suggestions to Boris Nagels, E-mail:
    boris@molphys.leidenuniv.nl

 *************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

void error(char *s)
{
	fprintf(stderr, "%s\n", s);
	exit(-1);
}

void main(int argc, char *argv[])
{
	char hulp[10], *data, filename[40];
	float seconds;
	long track_length, slicelen, written;
	int max_slicelen = 16384;
	int count, nr_tracks, track_fd;

	fprintf(stderr, "Give number of tracks to format: ");
	gets(hulp);
	nr_tracks = atoi(hulp);
	fprintf(stderr, "Track length [seconds]: ");
	gets(hulp);
	seconds = atof(hulp);
	track_length = (long) (seconds * 22050 * 2);	/* 16 bit, 22050 Hz */

	data = (char *) malloc(sizeof(char) * max_slicelen);
	bzero(data, max_slicelen);

	for (count = 0; count < nr_tracks; count++) {
		fprintf(stderr, "\nFormatting track %d...", count);
		sprintf(filename, "track%d.wav", count);
		track_fd = open(filename, O_WRONLY | O_CREAT, 0666);
		if (track_fd == -1)
			error("Cannot open Track-file for writing.");
		written = 0;
		do {
			slicelen = track_length - written;
			if (slicelen > max_slicelen)
				slicelen = max_slicelen;
			write(track_fd, data, slicelen);
			written += slicelen;
		}
		while (slicelen == max_slicelen);
		close(track_fd);
	}
	fprintf(stderr, "\nDone.\n");
}
