/*************************************************************************
    general.c -- last change: 20-1-1998

    Copyright (C) 1996-1998  Boris Nagels

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    Sent your comments and suggestions to Boris Nagels, E-mail:
    boris@molphys.leidenuniv.nl

 *************************************************************************/

#include "local.h"

int svgagui_initialized = FALSE, sleep_time = 5000;


void set_sleep_time(int time)
{
	sleep_time = time;
}


void init_svgagui(void)
{
	guiscreen.data = NULL;
	guiscreen.image_data = NULL;

	mouse.savescreen = NULL;
	mouse.visible = FALSE;
	mouse.num_cursors = 0;
	mouse.cursor_id = -1;	/* no mouse defined yet */
	
	set_sleep_time(5000);
	svgagui_initialized = TRUE;
}


int GuiGetMessage(void)
{
	int message = FALSE;
	
	switch (guiscreen.type) {
		case SVGALIB : 
			message = get_svga_message();
			break;
		case XLIB :
			message = get_X_message();
			break;
	}

	return message;
}


int GuiMouseGetButton(void)
{
	int button = FALSE;
	
	switch (guiscreen.type) {
		case SVGALIB : 
			button = get_svga_mouse_button();
			break;
		case XLIB :
			button = get_X_mouse_button();
			break;
	}

	return button;
}


char GuiKeyboardGetChar(void)
{
	char ch = '\0';
	
	switch (guiscreen.type) {
		case SVGALIB : 
			ch = get_svga_keyboard_char();
			break;
		case XLIB :
			ch = get_X_keyboard_char();
			break;
	}

	return ch;
}
